com.fasterxml.jackson.databind.node

## Class ObjectNode

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializable.Base
  - - com.fasterxml.jackson.databind.JsonNode
    - - com.fasterxml.jackson.databind.node.BaseJsonNode
      - - com.fasterxml.jackson.databind.node.ContainerNode<ObjectNode>
        - - com.fasterxml.jackson.databind.node.ObjectNode

- All Implemented Interfaces:
    TreeNode, JsonSerializable, JsonNodeCreator, Serializable, Iterable<JsonNode>

      public class ObjectNode
      extends ContainerNode<ObjectNode>
      implements Serializable

  Node that maps to JSON Object structures in JSON content.

  Note: class was `final` temporarily for Jackson 2.2.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<String,JsonNode>` | `_children`

    - ### Fields inherited from class com.fasterxml.jackson.databind.node.ContainerNode

      `_nodeFactory`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ObjectNode(JsonNodeFactory nc)`
    `ObjectNode(JsonNodeFactory nc, Map<String,JsonNode> kids)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JsonNode` | `_at(JsonPointer ptr)`
    `protected boolean` | `_childrenEqual(ObjectNode other)`
    `protected ObjectNode` | `_put(String fieldName, JsonNode value)`
    `JsonToken` | `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
    `ObjectNode` | `deepCopy()` Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children.
    `Iterator<JsonNode>` | `elements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
    `boolean` | `equals(Comparator<JsonNode> comparator, JsonNode o)` Entry method for invoking customizable comparison, using passed-in `Comparator` object.
    `boolean` | `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
    `Iterator<String>` | `fieldNames()`
    `Iterator<Map.Entry<String,JsonNode>>` | `fields()` Method to use for accessing all fields (with both names and values) of this JSON Object.
    `ObjectNode` | `findParent(String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
    `List<JsonNode>` | `findParents(String fieldName, List<JsonNode> foundSoFar)`
    `JsonNode` | `findValue(String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
    `List<JsonNode>` | `findValues(String fieldName, List<JsonNode> foundSoFar)`
    `List<String>` | `findValuesAsText(String fieldName, List<String> foundSoFar)`
    `JsonNode` | `get(int index)` Method for accessing value of the specified element of an array node.
    `JsonNode` | `get(String fieldName)` Method for accessing value of the specified field of an object node.
    `JsonNodeType` | `getNodeType()` Return the type of this node
    `int` | `hashCode()`
    `boolean` | `isEmpty()` Convenience method that is functionally same as:
    `boolean` | `isEmpty(SerializerProvider serializers)` Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.
    `boolean` | `isObject()`
    `JsonNode` | `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `JsonNode` | `path(String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `ObjectNode` | `put(String fieldName, BigDecimal v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, BigInteger v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, boolean v)` Method for setting value of a field to specified String value.
    `ObjectNode` | `put(String fieldName, Boolean v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ObjectNode` | `put(String fieldName, byte[] v)` Method for setting value of a field to specified binary value
    `ObjectNode` | `put(String fieldName, double v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, Double v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ObjectNode` | `put(String fieldName, float v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, Float v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ObjectNode` | `put(String fieldName, int v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, Integer v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `JsonNode` | `put(String fieldName, JsonNode value)` Deprecated. Since 2.4 use either `set(String,JsonNode)` or `replace(String,JsonNode)`,
    `ObjectNode` | `put(String fieldName, long v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, Long v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, short v)` Method for setting value of a field to specified numeric value.
    `ObjectNode` | `put(String fieldName, Short v)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ObjectNode` | `put(String fieldName, String v)` Method for setting value of a field to specified String value.
    `JsonNode` | `putAll(Map<String,? extends JsonNode> properties)` Deprecated. Since 2.4 use `setAll(Map)`,
    `JsonNode` | `putAll(ObjectNode other)` Deprecated. Since 2.4 use `setAll(ObjectNode)`,
    `ArrayNode` | `putArray(String fieldName)` Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
    `ObjectNode` | `putNull(String fieldName)`
    `ObjectNode` | `putObject(String fieldName)` Method that will construct an ObjectNode and add it as a field of this ObjectNode, replacing old value, if any.
    `ObjectNode` | `putPOJO(String fieldName, Object pojo)`
    `ObjectNode` | `putRawValue(String fieldName, RawValue raw)`
    `ObjectNode` | `remove(Collection<String> fieldNames)` Method for removing specified field properties out of this ObjectNode.
    `JsonNode` | `remove(String fieldName)` Method for removing field entry from this ObjectNode.
    `ObjectNode` | `removeAll()` Method for removing all field properties, such that this ObjectNode will contain no properties after call.
    `JsonNode` | `replace(String fieldName, JsonNode value)` Method for replacing value of specific property with passed value, and returning value (or null if none).
    `JsonNode` | `required(String fieldName)` Method is functionally equivalent to `path(fieldName).required()` and can be used to check that this node is an `ObjectNode` (that is, represents JSON Object value) and has value for specified property with key `fieldName` (but note that value may be explicit JSON null value).
    `ObjectNode` | `retain(Collection<String> fieldNames)` Method for removing all field properties out of this ObjectNode except for ones specified in argument.
    `ObjectNode` | `retain(String... fieldNames)` Method for removing all field properties out of this ObjectNode except for ones specified in argument.
    `void` | `serialize(JsonGenerator g, SerializerProvider provider)` Method that can be called to serialize this node and all of its descendants using specified JSON generator.
    `void` | `serializeWithType(JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
    `<T extends JsonNode> T` | `set(String fieldName, JsonNode value)` Method that will set specified field, replacing old value, if any.
    `<T extends JsonNode> T` | `setAll(Map<String,? extends JsonNode> properties)` Method for adding given properties to this object node, overriding any existing values for those properties.
    `<T extends JsonNode> T` | `setAll(ObjectNode other)` Method for adding all properties of the given Object, overriding any existing values for those properties.
    `int` | `size()`
    `ObjectNode` | `with(String propertyName)` Method that can be called on Object nodes, to access a property that has Object value; or if no such property exists, to create, add and return such Object node.
    `ArrayNode` | `withArray(String propertyName)` Method that can be called on Object nodes, to access a property that has `Array` value; or if no such property exists, to create, add and return such Array node.
    `<T extends JsonNode> T` | `without(Collection<String> fieldNames)` Method for removing specified field properties out of this ObjectNode.
    `<T extends JsonNode> T` | `without(String fieldName)` Method for removing field entry from this ObjectNode, and returning instance after removal.

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.ContainerNode

      `arrayNode, arrayNode, asText, binaryNode, binaryNode, booleanNode, missingNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, pojoNode, rawValueNode, textNode`

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode

      `findPath, numberType, required, toPrettyString, toString, traverse, traverse`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonNode

      `_reportRequiredViolation, _this, asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, asText, at, at, bigIntegerValue, binaryValue, booleanValue, canConvertToInt, canConvertToLong, decimalValue, doubleValue, findParents, findValues, findValuesAsText, floatValue, has, has, hasNonNull, hasNonNull, intValue, isArray, isBigDecimal, isBigInteger, isBinary, isBoolean, isContainerNode, isDouble, isFloat, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isPojo, isShort, isTextual, isValueNode, iterator, longValue, numberValue, require, requiredAt, requiredAt, requireNonNull, shortValue, textValue`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Field Detail

    - #### _children

          protected final Map<String,JsonNode> _children

  - ### Constructor Detail

    - #### ObjectNode

          public ObjectNode(JsonNodeFactory nc)

    - #### ObjectNode

          public ObjectNode(JsonNodeFactory nc,
                            Map<String,JsonNode> kids)

      Since:
        2.4

  - ### Method Detail

    - #### _at

          protected JsonNode _at(JsonPointer ptr)

      Specified by:
        `_at` in class `JsonNode`

    - #### deepCopy

          public ObjectNode deepCopy()

      Description copied from class: `JsonNode`
      Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children. This means it can either make a copy of this node (and all mutable children and grand children nodes), or node itself if it is immutable.

      Note: return type is guaranteed to have same type as the node method is called on; which is why method is declared with local generic type.

      Specified by:
        `deepCopy` in class `JsonNode`
      Returns:
        Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

    - #### isEmpty

          public boolean isEmpty(SerializerProvider serializers)

      Description copied from class: `JsonSerializable.Base`
      Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.
      Overrides:
        `isEmpty` in class `JsonSerializable.Base`

    - #### getNodeType

          public JsonNodeType getNodeType()

      Description copied from class: `JsonNode`
      Return the type of this node
      Specified by:
        `getNodeType` in class `JsonNode`
      Returns:
        the node type as a `JsonNodeType` enum value

    - #### isObject

          public final boolean isObject()

      Specified by:
        `isObject` in interface `TreeNode`
      Overrides:
        `isObject` in class `JsonNode`

    - #### asToken

          public JsonToken asToken()

      Description copied from class: `BaseJsonNode`
      Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)
      Specified by:
        `asToken` in interface `TreeNode`
      Specified by:
        `asToken` in class `ContainerNode<ObjectNode>`

    - #### size

          public int size()

      Specified by:
        `size` in interface `TreeNode`
      Specified by:
        `size` in class `ContainerNode<ObjectNode>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from class: `JsonNode`
      Convenience method that is functionally same as:

              size() == 0

      for all node types.
      Overrides:
        `isEmpty` in class `JsonNode`

    - #### elements

          public Iterator<JsonNode> elements()

      Description copied from class: `JsonNode`
      Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.
      Overrides:
        `elements` in class `JsonNode`

    - #### get

          public JsonNode get(int index)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

      For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

      NOTE: if the element value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

      Specified by:
        `get` in interface `TreeNode`
      Specified by:
        `get` in class `ContainerNode<ObjectNode>`
      Returns:
        Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

    - #### get

          public JsonNode get(String fieldName)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.

      NOTE: if the property value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

      Specified by:
        `get` in interface `TreeNode`
      Specified by:
        `get` in class `ContainerNode<ObjectNode>`
      Returns:
        Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

    - #### fieldNames

          public Iterator<String> fieldNames()

      Specified by:
        `fieldNames` in interface `TreeNode`
      Overrides:
        `fieldNames` in class `JsonNode`

    - #### path

          public JsonNode path(int index)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in interface `TreeNode`
      Specified by:
        `path` in class `JsonNode`

    - #### path

          public JsonNode path(String fieldName)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in interface `TreeNode`
      Specified by:
        `path` in class `JsonNode`

    - #### required

          public JsonNode required(String fieldName)

      Description copied from class: `JsonNode`
      Method is functionally equivalent to `path(fieldName).required()` and can be used to check that this node is an `ObjectNode` (that is, represents JSON Object value) and has value for specified property with key `fieldName` (but note that value may be explicit JSON null value). If this node is Object Node and has value for specified property, `this` is returned to allow chaining; otherwise `IllegalArgumentException` is thrown.
      Overrides:
        `required` in class `BaseJsonNode`
      Returns:
        `this` node to allow chaining

    - #### fields

          public Iterator<Map.Entry<String,JsonNode>> fields()

      Method to use for accessing all fields (with both names and values) of this JSON Object.
      Overrides:
        `fields` in class `JsonNode`
      Returns:
        Iterator that can be used to traverse all key/value pairs for object nodes; empty iterator (no contents) for other types

    - #### with

          public ObjectNode with(String propertyName)

      Description copied from class: `JsonNode`
      Method that can be called on Object nodes, to access a property that has Object value; or if no such property exists, to create, add and return such Object node. If the node method is called on is not Object node, or if property exists and has value that is not Object node, `UnsupportedOperationException` is thrown

      NOTE: since 2.10 has had co-variant return type

      Overrides:
        `with` in class `JsonNode`

    - #### withArray

          public ArrayNode withArray(String propertyName)

      Description copied from class: `JsonNode`
      Method that can be called on Object nodes, to access a property that has `Array` value; or if no such property exists, to create, add and return such Array node. If the node method is called on is not Object node, or if property exists and has value that is not Array node, `UnsupportedOperationException` is thrown

      NOTE: since 2.10 has had co-variant return type

      Overrides:
        `withArray` in class `JsonNode`

    - #### equals

          public boolean equals(Comparator<JsonNode> comparator,
                                JsonNode o)

      Description copied from class: `JsonNode`
      Entry method for invoking customizable comparison, using passed-in `Comparator` object. Nodes will handle traversal of structured types (arrays, objects), but defer to comparator for scalar value comparisons. If a "natural" `Comparator` is passed -- one that simply calls `equals()` on one of arguments, passing the other -- implementation is the same as directly calling `equals()` on node.

      Default implementation simply delegates to passed in `comparator`, with `this` as the first argument, and `other` as the second argument.

      Overrides:
        `equals` in class `JsonNode`
      Parameters:
        `comparator` - Object called to compare two scalar `JsonNode` instances, and return either 0 (are equals) or non-zero (not equal)

    - #### findValue

          public JsonNode findValue(String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findValue` in class `JsonNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findValues

          public List<JsonNode> findValues(String fieldName,
                                           List<JsonNode> foundSoFar)

      Specified by:
        `findValues` in class `JsonNode`

    - #### findValuesAsText

          public List<String> findValuesAsText(String fieldName,
                                               List<String> foundSoFar)

      Specified by:
        `findValuesAsText` in class `JsonNode`

    - #### findParent

          public ObjectNode findParent(String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findParent` in class `JsonNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findParents

          public List<JsonNode> findParents(String fieldName,
                                            List<JsonNode> foundSoFar)

      Specified by:
        `findParents` in class `JsonNode`

    - #### serialize

          public void serialize(JsonGenerator g,
                                SerializerProvider provider)
                         throws IOException

      Method that can be called to serialize this node and all of its descendants using specified JSON generator.
      Specified by:
        `serialize` in interface `JsonSerializable`
      Specified by:
        `serialize` in class `BaseJsonNode`
      Throws:
        `IOException`

    - #### serializeWithType

          public void serializeWithType(JsonGenerator g,
                                        SerializerProvider provider,
                                        TypeSerializer typeSer)
                                 throws IOException

      Description copied from class: `BaseJsonNode`
      Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
      Specified by:
        `serializeWithType` in interface `JsonSerializable`
      Specified by:
        `serializeWithType` in class `BaseJsonNode`
      Throws:
        `IOException`

    - #### set

          public <T extends JsonNode> T set(String fieldName,
                                            JsonNode value)

      Method that will set specified field, replacing old value, if any. Note that this is identical to `replace(String, JsonNode)`, except for return value.

      NOTE: added to replace those uses of `put(String, JsonNode)` where chaining with 'this' is desired.

      NOTE: co-variant return type since 2.10

      Parameters:
        `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(java.lang.String)` instead)
      Returns:
        This node after adding/replacing property value (to allow chaining)
      Since:
        2.1

    - #### setAll

          public <T extends JsonNode> T setAll(Map<String,? extends JsonNode> properties)

      Method for adding given properties to this object node, overriding any existing values for those properties.

      NOTE: co-variant return type since 2.10

      Parameters:
        `properties` - Properties to add
      Returns:
        This node after adding/replacing property values (to allow chaining)
      Since:
        2.1

    - #### setAll

          public <T extends JsonNode> T setAll(ObjectNode other)

      Method for adding all properties of the given Object, overriding any existing values for those properties.

      NOTE: co-variant return type since 2.10

      Parameters:
        `other` - Object of which properties to add to this object
      Returns:
        This node after addition (to allow chaining)
      Since:
        2.1

    - #### replace

          public JsonNode replace(String fieldName,
                                  JsonNode value)

      Method for replacing value of specific property with passed value, and returning value (or null if none).
      Parameters:
        `fieldName` - Property of which value to replace
        `value` - Value to set property to, replacing old value if any
      Returns:
        Old value of the property; null if there was no such property with value
      Since:
        2.1

    - #### without

          public <T extends JsonNode> T without(String fieldName)

      Method for removing field entry from this ObjectNode, and returning instance after removal.

      NOTE: co-variant return type since 2.10

      Returns:
        This node after removing entry (if any)
      Since:
        2.1

    - #### without

          public <T extends JsonNode> T without(Collection<String> fieldNames)

      Method for removing specified field properties out of this ObjectNode.

      NOTE: co-variant return type since 2.10

      Parameters:
        `fieldNames` - Names of fields to remove
      Returns:
        This node after removing entries
      Since:
        2.1

    - #### put

          @Deprecated
          public JsonNode put(String fieldName,
                                          JsonNode value)

      Deprecated. Since 2.4 use either `set(String,JsonNode)` or `replace(String,JsonNode)`,
      Method that will set specified field, replacing old value, if any.
      Parameters:
        `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(java.lang.String)` instead)
      Returns:
        Old value of the field, if any; null if there was no old value.

    - #### remove

          public JsonNode remove(String fieldName)

      Method for removing field entry from this ObjectNode. Will return value of the field, if such field existed; null if not.
      Returns:
        Value of specified field, if it existed; null if not

    - #### remove

          public ObjectNode remove(Collection<String> fieldNames)

      Method for removing specified field properties out of this ObjectNode.
      Parameters:
        `fieldNames` - Names of fields to remove
      Returns:
        This node after removing entries

    - #### removeAll

          public ObjectNode removeAll()

      Method for removing all field properties, such that this ObjectNode will contain no properties after call.
      Specified by:
        `removeAll` in class `ContainerNode<ObjectNode>`
      Returns:
        This node after removing all entries

    - #### putAll

          @Deprecated
          public JsonNode putAll(Map<String,? extends JsonNode> properties)

      Deprecated. Since 2.4 use `setAll(Map)`,
      Method for adding given properties to this object node, overriding any existing values for those properties.
      Parameters:
        `properties` - Properties to add
      Returns:
        This node after adding/replacing property values (to allow chaining)

    - #### putAll

          @Deprecated
          public JsonNode putAll(ObjectNode other)

      Deprecated. Since 2.4 use `setAll(ObjectNode)`,
      Method for adding all properties of the given Object, overriding any existing values for those properties.
      Parameters:
        `other` - Object of which properties to add to this object
      Returns:
        This node (to allow chaining)

    - #### retain

          public ObjectNode retain(Collection<String> fieldNames)

      Method for removing all field properties out of this ObjectNode except for ones specified in argument.
      Parameters:
        `fieldNames` - Fields to retain in this ObjectNode
      Returns:
        This node (to allow call chaining)

    - #### retain

          public ObjectNode retain(String... fieldNames)

      Method for removing all field properties out of this ObjectNode except for ones specified in argument.
      Parameters:
        `fieldNames` - Fields to retain in this ObjectNode
      Returns:
        This node (to allow call chaining)

    - #### putArray

          public ArrayNode putArray(String fieldName)

      Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.

      NOTE: Unlike all put(...) methods, return value is NOT this `ObjectNode`, but the newly created `ArrayNode` instance.

      Returns:
        Newly constructed ArrayNode (NOT the old value, which could be of any type)

    - #### putObject

          public ObjectNode putObject(String fieldName)

      Method that will construct an ObjectNode and add it as a field of this ObjectNode, replacing old value, if any.

      NOTE: Unlike all put(...) methods, return value is NOT this `ObjectNode`, but the newly created `ObjectNode` instance.

      Returns:
        Newly constructed ObjectNode (NOT the old value, which could be of any type)

    - #### putPOJO

          public ObjectNode putPOJO(String fieldName,
                                    Object pojo)

      Returns:
        This node (to allow chaining)

    - #### putRawValue

          public ObjectNode putRawValue(String fieldName,
                                        RawValue raw)

      Since:
        2.6

    - #### putNull

          public ObjectNode putNull(String fieldName)

      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                short v)

      Method for setting value of a field to specified numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Short v)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                int v)

      Method for setting value of a field to specified numeric value. The underlying `JsonNode` that will be added is constructed using `JsonNodeFactory.numberNode(int)`, and may be "smaller" (like `ShortNode`) in cases where value fits within range of a smaller integral numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Integer v)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                long v)

      Method for setting value of a field to specified numeric value. The underlying `JsonNode` that will be added is constructed using `JsonNodeFactory.numberNode(long)`, and may be "smaller" (like `IntNode`) in cases where value fits within range of a smaller integral numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Long v)

      Method for setting value of a field to specified numeric value. The underlying `JsonNode` that will be added is constructed using `JsonNodeFactory.numberNode(Long)`, and may be "smaller" (like `IntNode`) in cases where value fits within range of a smaller integral numeric value.

      Note that this is alternative to `put(String, long)` needed to avoid bumping into NPE issues with auto-unboxing.

      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                float v)

      Method for setting value of a field to specified numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Float v)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                double v)

      Method for setting value of a field to specified numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Double v)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                BigDecimal v)

      Method for setting value of a field to specified numeric value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                BigInteger v)

      Method for setting value of a field to specified numeric value.
      Returns:
        This node (to allow chaining)
      Since:
        2.9

    - #### put

          public ObjectNode put(String fieldName,
                                String v)

      Method for setting value of a field to specified String value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                boolean v)

      Method for setting value of a field to specified String value.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                Boolean v)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This node (to allow chaining)

    - #### put

          public ObjectNode put(String fieldName,
                                byte[] v)

      Method for setting value of a field to specified binary value
      Returns:
        This node (to allow chaining)

    - #### equals

          public boolean equals(Object o)

      Description copied from class: `JsonNode`
      Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

      Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

      Specified by:
        `equals` in class `JsonNode`

    - #### _childrenEqual

          protected boolean _childrenEqual(ObjectNode other)

      Since:
        2.3

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `BaseJsonNode`

    - #### _put

          protected ObjectNode _put(String fieldName,
                                    JsonNode value)

Copyright © 2008–2020 FasterXML. All rights reserved.